ClassFile.StackMapsOption (Java SE 25 & JDK 25)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: StackMapsOption
Keywords: java.lang.classfile.ClassFile.StackMapsOption class

# Enum Class ClassFile.StackMapsOption

java.lang.Object
java.lang.Enum<ClassFile.StackMapsOption>
java.lang.classfile.ClassFile.StackMapsOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.StackMapsOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.StackMapsOption extends Enum<ClassFile.StackMapsOption> implements ClassFile.Option
The option describing whether to generate stack maps. The default is `STACK_MAPS_WHEN_REQUIRED` to generate stack maps or reuse existing ones if compatible.

The `StackMapTableAttribute` is a derived property from a `Code` attribute to allow a Java Virtual Machine to perform verification in one pass. Thus, it is not modeled as part of a `CodeModel`, but computed on-demand instead via stack maps generation.

Stack map generation may fail with an `IllegalArgumentException` if there is unreachable code or legacy jump routine instructions. When `DROP_STACK_MAPS` option is used, users can provide their own stack maps by supplying a `StackMapTableAttribute` to a `CodeBuilder`.

See Java Virtual Machine Specification:
  4.10.1 Verification by Type Checking
Since:
  24
See Also:
  - `StackMapTableAttribute`
  - `ClassFile.DeadCodeOption`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DROP_STACK_MAPS`
  Do not run stack map generation.
  `GENERATE_STACK_MAPS`
  Forces running stack map generation.
  `STACK_MAPS_WHEN_REQUIRED`
  Generate stack maps or reuse existing ones if compatible.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.StackMapsOption`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.StackMapsOption[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### STACK_MAPS_WHEN_REQUIRED

    public static final ClassFile.StackMapsOption STACK_MAPS_WHEN_REQUIRED
    Generate stack maps or reuse existing ones if compatible. Stack maps are present on major versions 50 or above. For these versions, `CodeBuilder` tries to reuse compatible stack maps information if the code array and exception handlers are still compatible after a transformation; otherwise, it runs stack map generation. However, it does not fail fast if the major version is 50, which allows jump subroutine instructions that are incompatible with stack maps to exist in the `code` array.

  - ### GENERATE_STACK_MAPS

    public static final ClassFile.StackMapsOption GENERATE_STACK_MAPS
    Forces running stack map generation. This runs stack map generation unconditionally and fails fast if the generation fails due to any reason.

  - ### DROP_STACK_MAPS

    public static final ClassFile.StackMapsOption DROP_STACK_MAPS
    Do not run stack map generation. Users must supply their own `StackMapTableAttribute` to a `CodeBuilder` if the code has branches or exception handlers; otherwise, the generated code will fail verification (JVMS 4.10.1).

    This option is required for user-supplied `StackMapTableAttribute` to be respected. Stack maps on an existing `Code` attribute can be reused as below with this option:

        CodeAttribute code = method.findAttribute(Attributes.code()).orElseThrow();
        // Note that StackMapTable may be absent, representing code with no branching
        code.findAttribute(Attributes.stackMapTable()).ifPresent(cob);

- ## Method Details

  - ### values

    public static ClassFile.StackMapsOption[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.StackMapsOption valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null